

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Energy Market &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Package shyft.dashboard" href="../dashboard/installation.html" />
    <link rel="prev" title="Getting started with the Shyft energy market model" href="getting_started.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="getting_started.html">Getting started</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">API Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#module-shyft.energy_market.core">Core</a></li>
<li class="toctree-l2"><a class="reference internal" href="#module-shyft.energy_market.ltm">LTM</a></li>
<li class="toctree-l2"><a class="reference internal" href="#module-shyft.energy_market.stm">STM</a></li>
<li class="toctree-l2"><a class="reference internal" href="#module-shyft.energy_market.service">Service</a></li>
<li class="toctree-l2"><a class="reference internal" href="#ui">UI</a></li>
</ul>
</li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
      <li>Energy Market</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/content/energy_market/api.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="energy-market">
<h1>Energy Market<a class="headerlink" href="#energy-market" title="Permalink to this headline">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This is the complete exposed API.
Not all classes and functions are meant for the End-user, the documentation is a work in progress</p>
</div>
<div class="section" id="module-shyft.energy_market.core">
<span id="core"></span><h2>Core<a class="headerlink" href="#module-shyft.energy_market.core" title="Permalink to this headline">¶</a></h2>
<dl class="py exception">
<dt id="shyft.energy_market.core.EnergyMarketCorePropertyError">
<em class="property"><span class="pre">exception</span> </em><code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">EnergyMarketCorePropertyError</span></code><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#EnergyMarketCorePropertyError"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.EnergyMarketCorePropertyError" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">Exception</span></code></p>
<p>Error type for when a C++ object’s property fails, but
it shouldn’t attempt __getattr__ afterwards.</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.add_hydro_connection_lists">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">add_hydro_connection_lists</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">x</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">shyft.energy_market.core._core.HydroConnectionList</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">shyft.energy_market.core._core.HydroConnectionList</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#add_hydro_connection_lists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.add_hydro_connection_lists" title="Permalink to this definition">¶</a></dt>
<dd><p>Overloads the addition operator (+) for HydroConnectionList
:param self: A HydroConnectionList
:param x: Another HydroConnectionList
:return: self</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.add_methods_to_id_based_interface">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">add_methods_to_id_based_interface</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cls</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#add_methods_to_id_based_interface"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.add_methods_to_id_based_interface" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds Python-Dict methods to C++ std::vector (used for id-based dicts, e.g., std::vector&lt;<a href="#id1"><span class="problematic" id="id2">hydro_component_</span></a>&gt;)
:param cls: A Python-wrapped C++ std::vector object
:return: cls with methods items(), values(), and keys()</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.add_methods_to_name_based_interface">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">add_methods_to_name_based_interface</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cls</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#add_methods_to_name_based_interface"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.add_methods_to_name_based_interface" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds Python-Dict methods to C++ vector (used for name-based dicts, e.g., std::vector&lt;<a href="#id3"><span class="problematic" id="id4">hydro_power_system_</span></a>&gt;)
:param cls: A Python-wrapped C++ vector object
:return: cls with methods items(), values(), and keys()</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.create_model_service">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">create_model_service</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">model_directory</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">storage_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'blob'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#create_model_service"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.create_model_service" title="Permalink to this definition">¶</a></dt>
<dd><p>Create and return the client for the Ltm model service
:param model_directory: specifies the network host name, ip, name
:type model_directory: string
:param storage_type: specifies type of api-service, (‘blob’)</p>
<blockquote>
<div><p>default = ‘blob’</p>
</div></blockquote>
<dl class="field-list simple">
</dl>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.dict_class_str">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">dict_class_str</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">str</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#dict_class_str"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.dict_class_str" title="Permalink to this definition">¶</a></dt>
<dd><p>String representation for the Python-wrapped C++ Dict class.</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_dir">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_dir</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">List</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_dir"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_dir" title="Permalink to this definition">¶</a></dt>
<dd><p>Appends the content of __dir__ from the Python object to “self”
:param self: A python-wrapped C++ object
:return: [List] The updated self.__dir__()</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_id_based_items">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_id_based_items</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Generator</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_id_based_items"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_id_based_items" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a generator of elements contained in self (a C++ std::vector). Solely implemented to imitate the items()
method of a python dictionary.
:param self: A C++ std::vector object
:return: A generator containing a tuple of elements and the corresponding element ids</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_id_based_keys">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_id_based_keys</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Generator</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_id_based_keys"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_id_based_keys" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a generator for the element ids contained in self, which is a C++ std::vector object. The purpose of this
method is to imitate the keys() method of a Python dictionary.
:param self: A C++ std::vector object
:return: A generator containing a tuple of element ids</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_item_from_id">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_item_from_id</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_item_from_id"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_item_from_id" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the element in the self (C++ std::vector object) having key as index or element id.
:param self: A C++ std::vector object
:param key: An integer, slice or string (element id)
:return: The element with the corresponding key</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_item_from_name">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_item_from_name</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_item_from_name"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_item_from_name" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the element in the self (a C++ std::vector object) having key as index or element name.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>self</strong> – A C++ std::vector object</p></li>
<li><p><strong>key</strong> – An integer, slice or string (element name)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The element with the corresponding key</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_name_based_items">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_name_based_items</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Generator</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_name_based_items"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_name_based_items" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a generator of elements contained in self (a C++ std::vector). Solely implemented to imitate the items()
method of a python dictionary.
:param self: A C++ std::vector object
:return: A generator containing a tuple of elements and the corresponding element ids</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_name_based_keys">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_name_based_keys</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Generator</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_name_based_keys"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_name_based_keys" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a generator for the element names contained in self, which is a C++ std::vector object. The purpose of this
method is to imitate the keys() method of a Python dictionary.
:param self: A C++ std::vector object
:return: A generator containing a tuple of element names</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_object_attribute">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_object_attribute</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">attr</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_object_attribute"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_object_attribute" title="Permalink to this definition">¶</a></dt>
<dd><p>Exposes the attributes of self’s object to self (Self is a Python-wrapped C++ object and self’s object is a
Python object). Should be decorated with get_attribute_for_core_objects together with a suitable function to
construct self.obj from self.</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.get_values">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">get_values</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Generator</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#get_values"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.get_values" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a generator for the elements contained in self, which is a C++ std::vector object. The purpose of this
method is to imitate the values() method of a Python dictionary.
:param self: A C++ std::vector object
:return: A generator containing a tuple of elements</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.hydro_connection_list_str">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">hydro_connection_list_str</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">str</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#hydro_connection_list_str"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.hydro_connection_list_str" title="Permalink to this definition">¶</a></dt>
<dd><p>String representation for the Python-wrapped C++ HydroConnectionList class.</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.list_class_str">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">list_class_str</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">str</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#list_class_str"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.list_class_str" title="Permalink to this definition">¶</a></dt>
<dd><p>String representation for the C++ List classes.</p>
</dd></dl>

<dl class="py function">
<dt id="shyft.energy_market.core.no_getattr_if_exception">
<code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">no_getattr_if_exception</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">func</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">Callable</span><span class="p"><span class="pre">[</span></span><span class="p"><span class="pre">[</span></span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">,</span> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span> &#x2192; <span class="pre">Callable</span><span class="p"><span class="pre">[</span></span><span class="p"><span class="pre">[</span></span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">,</span> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#no_getattr_if_exception"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.no_getattr_if_exception" title="Permalink to this definition">¶</a></dt>
<dd><p>Decorator for energy_market.core properties that might throw AttributeErrors,
but that we don’t want to continue into __getattr__.
Instead we want it to throw the error received from the first attempt.</p>
</dd></dl>

<dl class="py class">
<dt id="shyft.energy_market.core.requires_data_object">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">shyft.energy_market.core.</span></code><code class="sig-name descname"><span class="pre">requires_data_object</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">construct_func</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/core.html#requires_data_object"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.core.requires_data_object" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></p>
<p>Decorator class for functions for lazy evaluations of Energy Market Core object attributes.
The decorator checks whether “obj”-attribute has been set, and if not, applies a user-defined function
to construct obj, before making the function call.</p>
</dd></dl>

</div>
<div class="section" id="module-shyft.energy_market.ltm">
<span id="ltm"></span><h2>LTM<a class="headerlink" href="#module-shyft.energy_market.ltm" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-shyft.energy_market.stm">
<span id="stm"></span><h2>STM<a class="headerlink" href="#module-shyft.energy_market.stm" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt id="shyft.energy_market.stm.ReadAccess">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">shyft.energy_market.stm.</span></code><code class="sig-name descname"><span class="pre">ReadAccess</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">mtx</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">shyft.energy_market.stm._stm.SharedMutex</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/stm.html#ReadAccess"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.stm.ReadAccess" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></p>
<p>Context manager for read-only operation with a SharedMutex</p>
</dd></dl>

<dl class="py class">
<dt id="shyft.energy_market.stm.UpgradableAccess">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">shyft.energy_market.stm.</span></code><code class="sig-name descname"><span class="pre">UpgradableAccess</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">mtx</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">shyft.energy_market.stm._stm.SharedMutex</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/stm.html#UpgradableAccess"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.stm.UpgradableAccess" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></p>
<p>Context manager for shared-access to a mutex. Can then later be upgraded to exclusive access rights.</p>
</dd></dl>

<dl class="py class">
<dt id="shyft.energy_market.stm.WriteAccess">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">shyft.energy_market.stm.</span></code><code class="sig-name descname"><span class="pre">WriteAccess</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">rl</span></span><span class="p"><span class="pre">:</span></span> <span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">shyft.energy_market.stm._stm.UpgradableLock</span><span class="p"><span class="pre">,</span> </span><span class="pre">shyft.energy_market.stm._stm.SharedMutex</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../../_modules/shyft/energy_market/stm.html#WriteAccess"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#shyft.energy_market.stm.WriteAccess" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></p>
<p>Context manager for exclusive right to a mutex.</p>
</dd></dl>

</div>
<div class="section" id="module-shyft.energy_market.service">
<span id="service"></span><h2>Service<a class="headerlink" href="#module-shyft.energy_market.service" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="ui">
<h2>UI<a class="headerlink" href="#ui" title="Permalink to this headline">¶</a></h2>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../dashboard/installation.html" class="btn btn-neutral float-right" title="Package shyft.dashboard" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="getting_started.html" class="btn btn-neutral float-left" title="Getting started with the Shyft energy market model" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>